import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class ProofDogbone  {

    public static void main(Manager M) {
	for(int i=1;i<6;++i) {
	    match(i,false);
	    match(i,true); 
           Integer I=new Integer(i);
	  M.C.MESSAGE[i]="dogbone "+I.toString()+" test done";
	  M.C.repaint();
	}
    }

    /**This routine checks that the listed PET itineraries
       for each partition2 polyhedron is correct, and it 
       returns the final list of displacement vectors.
       This list is Pi(X2-X0) where
   
       X0 is the partition2 polyhedron
       X2=f^2(X0)
       Pi is projection onto the first 2 coords. The last coord is 0.*/

    public static void match(int SHIFT,boolean up) {
	System.out.print("dogbone start: ");
	for(int i=0;i<40;++i) {
	    boolean test=match(SHIFT,i,up);
	   if(test==false) System.out.println("fail "+i);
	}
	System.out.println("done");
    }

    public static boolean match(int SHIFT,int i,boolean up) {
	LongPolyhedron X=DataPartition2.poly(i);
	int[] t=DataItinerary.dogbone1(i,up);
	if(SHIFT==2) t=DataItinerary.dogbone2(i,up);
	if(SHIFT==3) t=DataItinerary.dogbone3(i,up);
	if(SHIFT==4) t=DataItinerary.dogbone4(i,up);
	if(SHIFT==5) t=DataItinerary.dogbone5(i,up);
	int u=DataItinerary.upOrDown(i);

	LongPolygon M=PETMove(i);
	for(int j=0;j<X.count;++j) {
	  long s=X.V[j].x[2];
	  LongPolygon P=BilliardsVerify.getShape(s,X.SCALE);
	  LongComplex z=new LongComplex(X.V[j].x[0]+2*X.SCALE*SHIFT,X.V[j].x[1]);
	  if(up==true) z=new LongComplex(z.x+2*s-2*X.SCALE,z.y+2*s);
	  LongComplex w=BilliardsVerify.dogbone(P,z,t,u,up,X.SCALE);
	  LongComplex match=LongComplex.minus(w,M.z[j]);
	  if((match.x!=0)||(match.y!=0)) System.out.println("fail "+i+" "+j);
	}
	return(true);
    }

    public static LongPolygon PETMove(int i) {
          LongPolyhedron X0=DataPartition2.poly(i);
	  int q1=ProofSupport.insidePartition(X0);
	  LongPolyhedron X1=ProofSupport.dogboneMap(1,q1,X0);
	  int q2=ProofSupport.insidePartition(X1);
	  LongPolyhedron X2=ProofSupport.dogboneMap(1,q2,X1);
	  LongPolygon Y=new LongPolygon();
	  Y.count=X1.count;
	  for(int j=0;j<X1.count;++j) {
	      long x=X2.V[j].x[0]-X0.V[j].x[0];
	      long y=X2.V[j].x[1]-X0.V[j].x[1];
	      Y.z[j]=new LongComplex(x,y);
	  }
	  return(Y);
    }

}    










